//
//
// @author: Les
// OpenGarage - Google Home integration for open garage including door status.  This should be run on firebase, see other example for running on own server.
// Thanks to google for posting bitcoin example
// @date: Mar 2018
//
//
'use strict';

process.env.DEBUG = 'actions-on-google:*';

// We need the Assistant client for all the magic here
const Assistant = require('actions-on-google').DialogflowApp;
// To make our http request (a bit nicer)
const request = require('request');

// the actions we are supporting (get them from api.ai)
const ACTION_STATUS = 'status';
const ACTION_OPEN = 'open';
const ACTION_CLOSE = 'close';

// The end-points to our calls - adjust to garage though Blynk API
const EXT_GARAGE_API_URL = "http://blynk-cloud.com/your_blynk_id";
const EXT_STATUS = "/get/v0";
const EXT_OPEN = "/update/v1?value=1";
const EXT_CLOSE = "/update/v2?value=1";

var newmsg="empty field";

// [START Garage communication Info]
const garageInfo = (req, res) => {
  const assistant = new Assistant({request: req, response: res});
  console.log('garageInfoAction Request headers: ' + JSON.stringify(req.headers));
  console.log('garageInfoAction Request body: ' + JSON.stringify(req.body));

  // Get garage status notification
  function statusHandler (assistant) {
    request(EXT_GARAGE_API_URL + EXT_STATUS, function(error, response, body) {
      // The fulfillment logic for returning the bitcoin current price
      console.log("statusHandler response: " + JSON.stringify(response) + " Body: " + body + " | Error: " + error);
        if( body = 1 ) {
         newmsg = "open";
        } else if( body = 0) {
          newmsg = "closed";
          }

      const msg = "The garage door is " + newmsg;
	  assistant.tell(msg);
	 //if you want to answer and wait for a further question use ask instead of tell
	 //assistant.ask(msg);
	  });
  }

  // Open the garage door
  function openHandler (assistant) {
    request(EXT_GARAGE_API_URL + EXT_OPEN, function(error, response, body) {
      console.log("openHandler response: " + JSON.stringify(response) + " Body: " + body + " | Error: " + error);
      const msg = "Opening the garage door.";
      assistant.tell(msg);
    });
  }
  
  // Fulfill block count action
  function closeHandler (assistant) {
    request(EXT_GARAGE_API_URL + EXT_CLOSE, function(error, response, body) {
      console.log("closeHandler response: " + JSON.stringify(response) + " Body: " + body + " | Error: " + error);
      const msg = "Closing the garage door.";
      assistant.tell(msg);
    });
  }

  // The Entry point to all our actions
  const actionMap = new Map();
  actionMap.set(ACTION_STATUS, statusHandler);
  actionMap.set(ACTION_OPEN, openHandler);
  actionMap.set(ACTION_CLOSE, closeHandler);

  assistant.handleRequest(actionMap);
};
// [END Garage Info]
const functions = require('firebase-functions');
exports.dialogflowFirebaseFulfillment = functions.https.onRequest( garageInfo );

var newrequest = require('request');
newrequest('http://blynk-cloud.com/your_blynk_id/get/v0', function (error, response, body) {
  console.log('error:', error); // Print the error if one occurred
//  console.log('statusCode:', response && response.statusCode); // Print the response status code if a response was received
  console.log('body:', body); // Print the HTML for the website.
});

// [END Bitcoin Info]